// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


#include <cstddef> // IWYU pragma: keep

#include "Utilities/LinearAlgebra/Type.hpp"

#include "Test/Operators/VariationalInstances/Viscoelasticity/ExpectedResults.hpp"


// NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers,modernize-use-std-numbers)
namespace MoReFEM::TestNS::ViscoelasticityNS
{


    template<>
    expected_results_type<LinearAlgebraNS::type::matrix>
    GetExpectedMatrixP2P1<Advanced::LocalVariationalOperatorNS::SecondPiolaKirchhoffStressTensorNS::
                              ViscoelasticityPolicyNS::DerivatesWithRespectTo::displacement_and_velocity>()
    {
        return expected_results_type<LinearAlgebraNS::type::matrix>{
            { 8.8294380847425380e-01,  1.0786979698366805e+00,  -2.6388216218234550e-01, 2.0951531492612263e+00,
              2.8140061647375738e+00,  4.8844217810134194e-01,  7.9403984780634396e-01,  7.1453436789823899e-01,
              2.4554034908552227e-01,  -2.4030602029329970e+00, -2.2151795212359668e+00, -9.0505295109165795e-01,
              4.5738783915551522e+01,  -9.1184590838793849e+00, -4.0487666345219884e+00, -4.7069530523335800e+01,
              -1.8918854559391796e+01, -2.0395571429511506e+01, 4.6668947821660581e+01,  1.7400759755384641e+01,
              2.1746236163209218e+01,  5.7929530138445514e+01,  3.0583351377804817e+01,  2.8381726003144976e+01,
              -5.1838175623096497e+01, -2.3780597876199877e+01, -2.7109381792399102e+01, -5.2798632331834135e+01,
              1.4417414050450730e+00,  1.8607102761655510e+00 },
            { 1.1034263846010852e+00,  3.0583771603564456e+00,  1.2898146154524319e+00,  1.5915498415073615e+00,
              2.7800460857527654e+00,  5.1547523890181002e-01,  1.2732265786279442e+00,  1.6026417334259837e+00,
              2.2820724080673509e+00,  -2.5738375186265827e+00, -1.1349422898039330e+00, -5.7259604600471969e-01,
              1.4980696407221147e+01,  3.8775291094500638e+01,  2.0791788026934121e+01,  -1.8934761262523118e+01,
              -4.5247723471903356e+01, -1.9414439074762711e+01, -7.2291094393562849e+00, 4.4348599948022589e+01,
              -9.8380676657892234e+00, 3.0908416689347312e+01,  5.3455362516312391e+01,  2.6466722737241778e+01,
              2.2297080838275036e+00,  -4.8775200658050423e+01, 1.2047267308619229e+00,  -2.3349315764626365e+01,
              -4.8862452118613078e+01, -2.2725496970902761e+01 },
            { -2.4913671037821783e-01, 1.3162450856080099e+00,  1.2915523827091002e+00,  -1.7645681007195740e-01,
              -2.4851893516978099e-01, -6.4872444591501477e-01, 1.0366381012982626e+00,  9.5150433584219862e-01,
              1.7716150068616403e+00,  -2.8975541745314852e+00, -2.8803039753862980e+00, -1.2775190083338948e+00,
              2.2713984182780095e+01,  2.0687983500276793e+01,  5.3815471589345748e+01,  2.6040004531826964e+00,
              4.6628821693667444e+00,  -5.1063247367888231e+01, 2.0271543695483828e+01,  1.6451884947341892e+01,
              4.6287774262242991e+01,  2.8566313431486550e+00,  1.4267209622941524e-01,  5.5393778423432543e+01,
              -2.3570374216153276e+01, -2.1842606367382889e+01, -5.5071297422901758e+01, -2.2589275864758598e+01,
              -1.9241742856726081e+01, -5.0499403419553119e+01 },
            { -9.1103547784911587e-02, -3.5762552516266349e-01, 4.0058490032620503e-01,  -1.6185161564322603e+00,
              -1.6676468803241749e+00, 1.8176721943277596e-01,  4.3671370497165646e-01,  4.7691401332707545e-03,
              1.7310445267693084e-02,  2.7263948503451368e-01,  -4.0273823313177561e-02, -1.1391757796101789e-02,
              5.0638563365260483e+00,  1.9597786249827602e+00,  -5.2003691513117678e-01, 2.3712910400997234e+01,
              -1.3622679533627293e+00, -1.4039117030005763e+00, -2.4833331864710484e+01, 1.3745076141963934e+00,
              1.3386549721373804e+00,  -2.9102968796500505e+01, -1.1919068123013763e+00, -2.5028028112779360e-01,
              2.8171204901712358e+01,  1.2220936811488248e+00,  2.5222063075350087e-01,  -2.0114044638136552e+00,
              5.8571934002872479e-02,  -4.9175108619068601e-03 },
            { -7.8395427235298731e-01, -1.4846632261361257e+00, -2.0581019033998554e-01, -1.6852392619249530e+00,
              -1.9949287541018159e+00, 3.7947425732341156e-01,  -4.5887021850186605e-01, -1.1293529681167664e+00,
              -6.3942830593793065e-01, 6.4234311848355197e-01,  -6.1766834499020519e-02, -1.1979646523684124e-02,
              -2.0558618544600812e+01, 3.7551121615173471e+00,  -6.4603217850464312e-01, 2.2150952914193361e+01,
              2.4295109237766912e+01,  -2.6449438008488562e+00, 5.1506958705868415e+00,  -2.3576901967408524e+01,
              3.7244946809565533e+00,  -2.9163083275531562e+01, -2.6909811448798006e+01, 3.2071350006482452e-01,
              2.2467550716679568e-01,  2.5359948833096649e+01,  -1.3281264221200273e+00, 2.4481098162481636e+01,
              1.7472549666793549e+00,  1.0516381059303375e+00 },
            { -5.2558562731133573e-01, -5.0532968549601420e-01, -6.6639691366864984e-02, 1.7579382681529185e-01,
              3.6351459231278616e-01,  7.4220978664284276e-01,  -3.0459258576025910e-01, 3.4676181337491827e-02,
              1.3347784849134224e-02,  1.5331113479176728e+00,  1.5793615183052139e+00,  5.7361902420472233e-01,
              -2.5754103240747863e+01, 4.6795697047425838e-01,  -1.2004878601627123e+00, -2.1441549457847486e+00,
              -2.9318465518950405e+00, 2.4863605374316826e+01,  -2.2744622788310458e+01, 3.9487382115900425e+00,
              -2.4670407715519818e+01, -9.0744470718925951e-01, 2.0956592580915412e-01,  -2.7616842751024379e+01,
              2.6210115158172300e+01,  -2.1451393834413115e+00, 2.7594857588871431e+01,  2.4461483562198651e+01,
              -1.0214977789965805e+00, -2.3326154081118788e-01 },
            { -6.6476258827021995e-01, -7.9596324482705971e-01, -2.2211188443481239e-01, -8.1237084136856264e-01,
              -1.7755332388796250e+00, -1.8431860549462947e-01, -1.2020137409227787e+00, -7.1448337790705874e-01,
              -7.2621653955810361e-01, -2.8115420905585366e-02, 3.0171985467467888e-01,  2.0228008513355315e-03,
              -2.4553668278908223e+01, 5.9391332580731975e+00,  1.2692087817773106e+00,  2.4539831200946271e+01,
              2.2557854063847394e+01,  -1.2766963758286203e+00, 2.5086783774164494e+00,  -2.2602629993109620e+01,
              1.1311517837771892e+00,  -2.8199324217716068e+01, -2.8788304057813086e+01, 3.2777986477685173e-01,
              -6.5733866906133798e-01, 2.5920153458744327e+01,  -6.1060394852145938e-01, 2.9069084178790064e+01,
              -4.1946722803154937e-02, 2.8978412265493819e-01 },
            { -4.3732077718692952e-01, -1.0370751049501854e+00, -2.5173511468056756e-02, 7.1664500574440348e-02,
              -8.1286586903593028e-01, 1.7217009388495502e-02,  -7.1504124782625211e-01, 2.9693968984717956e-01,
              -1.0414966459620687e+00, -2.7857333819591754e-02, 6.4170548108334602e-01,  -7.3752692535981879e-03,
              2.3122782637392807e+00,  -2.0583703183735416e+01, 1.5165255459449587e+00,  -2.4149074330572069e+00,
              2.1699631494552435e+01,  -1.4846662020527757e+00, 1.0705113152257661e+00,  4.1649328549147846e+00,
              9.7109094408841634e-01,  -1.1234539007165736e+00, -2.8035510811608997e+01, 1.3205692467922470e+00,
              4.3116646673682861e-02,  7.0144950498099390e-01,  -3.1057805394112807e-03, 1.2210099663933831e+00,
              2.2964495943951786e+01,  -1.2635853369382068e+00 },
            { 3.4991098111948937e-01,  -8.1205375939228985e-01, -5.4270940231550957e-01, -4.4508564263029083e-03,
              -1.1478787398147179e-01, -8.3349904591289211e-03, -7.5675238209438267e-01, -1.0416197459419954e+00,
              -1.4824117618182191e+00, 4.1500991996095482e-01,  7.0178103054103169e-01,  -1.1177320965038823e-01,
              2.5896795361457525e+00,  -2.2680301886345301e+01, -2.6430826356692382e+01, -4.9159094033344941e-01,
              -1.8087441657618220e+00, 2.7137659361734428e+01,  1.1239078290109759e+00,  -2.3223344596943072e+01,
              2.1614333602781342e+00,  -6.4758675697077528e-01, 1.7930636673652600e-01,  -2.6432023716175607e+01,
              -2.1227598311937785e+00, 2.5566436156736028e+01,  -7.0176571177254210e-01, -4.5536749921848430e-01,
              2.3233328474352362e+01,  2.6410752426871206e+01 },
            { -1.2707767241912182e-01, 7.4890800153042836e-02,  8.5409146290953197e-02,  3.3573384853959681e-01,
              6.2917395446622648e-01,  -4.8589079203948815e-01, -2.8739811855220638e-02, -4.8201301244509016e-03,
              4.6336574520488838e-01,  2.1585361388040685e+00,  1.9537334898744654e+00,  9.1442190803642431e-01,
              -2.6248971973169343e+01, 1.2195472008234285e+00,  3.2995947678758539e+00,  -1.1832110786076990e+00,
              -2.2767315510928698e+00, 2.3076179508340704e+01,  -2.4344294334366548e+01, 3.8273626235285816e+00,
              -2.4216042919123794e+01, -6.2723712422894362e-01, -6.0314050769036243e-01, -2.8459225586794034e+01,
              2.4324309390445478e+01,  -3.3616492636932720e+00, 2.7467765110167065e+01,  2.5740952616857733e+01,
              -1.4583666162447901e+00, -2.1455768879585824e+00 },
            { 1.1784866493883189e-01,  -5.3663882927013185e-01, -1.0588309136443890e+00, 2.2024919843151188e-02,
              2.7748537384982477e-02,  -9.1216650561371693e-01, -9.9315112299825148e-02, -7.7022845515639704e-01,
              -6.0114745616735155e-01, 1.9593517339626227e+00,  5.5500364321960705e-01,  5.9195096178200202e-01,
              3.2656438736403848e+00,  -2.1946700072282567e+01, -2.1662281394374439e+01, -8.0128421861303667e-01,
              -7.4701726041598082e-01, 2.3544049077664344e+01,  1.0079022535436768e+00,  -2.4936630835528845e+01,
              5.1424820407442526e+00,  -6.2187951309917078e-01, 1.4899597440946175e+00,  -2.8108005484098850e+01,
              -2.4975002376679822e+00, 2.2713802319972782e+01,  1.2650547179751559e-01,  -2.3527923642486521e+00,
              2.4150701207981932e+01,  2.2937444201910630e+01 },
            { 4.2481135657006475e-01,  1.1383592802954035e-03,  -6.8220328902672456e-01, 5.1138396829684026e-03,
              -2.0778316153343313e-04, -8.5150350268699215e-02, 2.4706866556379027e-02,  5.5439228762304865e-02,
              -3.0255102989255411e-01, 9.4943290665285696e-01,  5.9916142654005278e-01,  8.1567319377956049e-01,
              4.5043952182201608e-01,  1.5243614155942482e+00,  -2.6184157372490645e+01, 3.1745432935501527e-02,
              7.7708548290118168e-02,  -9.3801736816302839e-01, 1.3491712638156510e+00,  2.8227214380111412e+00,
              -2.3778799907001307e+01, -1.3015998789886201e+00, -5.3154438877509558e-01, -1.3449119562325564e+00,
              -5.1698111082524911e-01, -1.5786904059118292e+00, 2.8178205545802868e+01,  -1.4168401982215677e+00,
              -2.9700878386297012e+00, 2.4321912533493084e+01 }
        };
    }


    template<>
    expected_results_type<LinearAlgebraNS::type::vector>
    GetExpectedVectorP2P1<Advanced::LocalVariationalOperatorNS::SecondPiolaKirchhoffStressTensorNS::
                              ViscoelasticityPolicyNS::DerivatesWithRespectTo::displacement_and_velocity>()
    {
        return expected_results_type<LinearAlgebraNS::type::vector>{
            0.026707676206855515,  -0.023799949026614725, -0.04374928780187741,  0.008475207120205773,
            -0.005901542458782882, -0.013638763198605344, -0.013003414592682807, 0.0049101285205963826,
            0.033079776067729216,  -0.02217946873437848,  0.02479136296480122,   0.024308274932753532
        };
    }


} // namespace MoReFEM::TestNS::ViscoelasticityNS
// NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers,modernize-use-std-numbers)

// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
